/**
 * Clones the provided array and passes it to the provided callback.
 * If any properties are changed in the callback, the clone is returned, the original otherwise.
 */
export declare function withChanges<T>(original: ReadonlyArray<T>, callback: (original: T[]) => void): T[];
/**
 * Clones the provided object and passes it to the provided callback.
 * If any properties are changed in the callback, the clone is returned, the original otherwise.
 */
export declare function withChanges<O extends Object>(original: Readonly<O>, callback: (original: O) => void): O;
/**
 * Clones the provided object if any of the properties would change, returns the original otherwise.
 */
export declare function withChanges<O extends Object, K extends keyof O>(original: Readonly<O>, assignment: {
    [P in K]: O[P];
}): O;
